/*******************************************************************************
 * Copyright (c) 2012 protos software gmbh (http://www.protos.de).
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 * 
 * CONTRIBUTORS:
 * 		Henrik Rentz-Reichert (initial contribution)
 * 
 *******************************************************************************/

grammar org.eclipse.etrice.core.etmap.ETMap with org.eclipse.etrice.core.common.Base

import "http://www.eclipse.org/emf/2002/Ecore" as ecore
import "http://www.eclipse.org/etrice/Room" as room
import "http://www.eclipse.org/etrice/core/etphys/ETPhys" as phys

import "http://www.eclipse.org/etrice/core/etmap/ETMap"

MappingModel:
	'MappingModel' name=FQN '{'
		(imports+=Import)*
		mappings+=Mapping*
	'}'
;

Mapping:
	'Mapping' logicalSys=[room::LogicalSystem|FQN] '->' physicalSys=[phys::PhysicalSystem|FQN] '{'
		subsysMappings+=SubSystemMapping*
	'}'
;

SubSystemMapping:
	'SubSystemMapping' logicalSubSys=[room::SubSystemRef|ID] '->' node=[phys::NodeRef|ID] ('{'
		threadMappings+=ThreadMapping*
	'}')?
;

ThreadMapping:
	'ThreadMapping' logicalThread=[room::LogicalThread|ID] '->' physicalThread=[phys::PhysicalThread|ID]
;
